﻿#region Copyright Syncfusion Inc. 2001 - 2011
// Copyright Syncfusion Inc. 2001 - 2011. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Threading;
using System.Windows;
using Syncfusion.Windows.Chart;
using System.Windows.Threading;
using System.Windows.Data;


namespace FastChartTypesDemo
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 
    {
        readonly DataGenerator dataGenerator = new DataGenerator();
        private readonly ObservableCollection<Data> serieDataList;
        DispatcherTimer timer = new DispatcherTimer();
        int i = 0;
        int hour = 0;
        public Window1()
        {
            InitializeComponent();

            
           //Chart1.Areas[0].PrimaryAxis.DateTimeInterval = new TimeSpan(1, 0, 0);
          // Chart1.Areas[0].PrimaryAxis.MinimumDateTimeInterval = new TimeSpan(1, 0, 0);
            timer.Tick += new EventHandler(timer_Tick);
            serieDataList = new ObservableCollection<Data>();
            
            Chart1.Areas[0].Series.Add(new ChartSeries
            {
                Label = dataGenerator.DataSeries[0].Name,
                Type = ChartTypes.FastLine,
                DataSource = serieDataList,
                BindingPathX = "Time",
                IsIndexed = false,
                BindingPathsY = new[] { "Value" },

            });
        }

        void timer_Tick(object sender, EventArgs e)
        {
            if (i < dataGenerator.DataSeries[0].Datas.Count)
            {
                serieDataList.Add(new Data()
                {
                    Time = dataGenerator.DataSeries[0].Datas[i].Time,
                    Value = dataGenerator.DataSeries[0].Datas[i].Value
                });

                hour=dataGenerator.DataSeries[0].Datas[i].Time.Hour+1;
               
                Chart1.Areas[0].Series[0].DataSource = serieDataList;
                Chart1.Areas[0].PrimaryAxis.DateTimeRange = new DateTimeRange(new DateTime(2013, 5, 12, 08, 48, 00), new DateTime(2013, 5, 12, hour, 00, 00));
                
                i++;
            }
            else
            {
                timer.Stop();
            }
            
        }

        private void AddSerie()
        {
            
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Chart1.Areas[0].PrimaryAxis.IsAutoSetRange = false;
            
            serieDataList.Clear();
            i = 0;
            timer.Start();           
        }

         
    }

    public class DataGenerator
    {
        private List<DataSerie> dataSeries;

        public DataGenerator()
        {
            dataSeries = this.GenerateData("..\\..\\Data\\nikkey.csv");
        }

        public List<DataSerie> DataSeries
        {
            get { return dataSeries; }
        }


        public List<DataSerie> GenerateData(string fileName)
        {

            char[] comma = new char[] { ',' };
            char[] slashN = new char[] { '\n' };
            string s = File.ReadAllText(fileName);

            string[] lines = s.Split(slashN);

            string[] values;
            int count = lines.Count();

            values = lines[0].Split(comma);
            var vCount = values.Count();
            int serieCount = vCount / 2;

            var dataSeries = new List<DataSerie>(serieCount);
            for (int si = 0; si < serieCount; ++si)
            {
                dataSeries.Add(new DataSerie
                {
                    Name = values[si * 2 + 1],
                    Datas = new ObservableCollection<Data>()
                });
            }

            for (int i = 1; i < count; ++i)
            {
                values = lines[i].Split(comma);
                if (values.Count() != vCount)
                    continue;

                for (int si = 0; si < serieCount; ++si)
                {


                    var dateStr = values[si * 2];
                    var valuesStr = values[si * 2 + 1];

                    DateTime pointDateTime;

                    if (String.IsNullOrEmpty(dateStr) || !DateTime.TryParse(dateStr, out pointDateTime))
                    {
                        continue;
                    }
                    double pointValue;
                    if (String.IsNullOrEmpty(valuesStr) || !double.TryParse(valuesStr, out pointValue))
                    {
                        continue;
                    }

                    dataSeries[si].Datas.Add(new Data { Time = pointDateTime, Value = pointValue });
                }
            }

            return dataSeries;
        }
    }

    public class DataSerie
    {
        public string Name { get; set; }
        public ObservableCollection<Data> Datas { get; set; }
    }

    public class Data
    {
        public DateTime Time { get; set; }
        public double Value { get; set; }
    }

    public class Labelconverter : IValueConverter     
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (((ChartAxisLabel)(value)).Content.ToString() == "08:48")
            {
                return null;
            }
            else
            {
                return value;
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

}

   

    

